## Script (Python) "getDictCommon"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=viewname
##title=Get dictionary of info common to all views
##
"""
returns a dictionary of useful objects for the calendar views

modified for CalendarX 0.4.0(dev) to use context instead of skinobj and 
 handle subcalendars, and change the URLhelp value
Released under the GPL (see LICENSE.txt)
viewname = string name of the view page template
IMPORTANT:  If you add a new view to your calendar, it must be added in here.  See code.
"""
request = container.REQUEST

#get from Property Sheets (true or false right now)
ampm = context.getCXAttribute('hoursDisplay') == '12ampm'
viewstarthour = int(context.getCXAttribute('dayViewStartHour'))
viewendhour = int(context.getCXAttribute('dayViewEndHour'))


#get from request (querystring), or default
try: xmy = request.xmy
except AttributeError: xmy = '0'
try: 
    xsub = request.xsub
#    if not 'ALL' in xsub:   CAN'T USE THIS IN PYTHON pre-2.3 APPARENTLY
    if string.count(xsub,'ALL') == 0:
        xsub = context.makeCSV(xsub)
    else:
        xsub = 'ALL' 
except AttributeError: xsub = 'ALL'
try: xpub = request.xpub
except AttributeError: xpub = '1'
try: xcrt = request.xcrt
except AttributeError: xcrt = '0'

#first set currentDate from the request, then override it from the Jump widget, if available
try: 
    currentDateTemp = request.currentDate
    currentDate = DateTime(str(currentDateTemp))
except: 
    currentDateTemp = DateTime()
    currentDate = DateTime(str(currentDateTemp))
if hasattr(request,'jumpyear'):
    try:
        year = str(request.jumpyear)
        month = str(request.jumpmonth)
        day = str(request.jumpday)
        newdatestr = year+'/'+month+'/'+day
        currentDateTemp = DateTime(newdatestr)
        currentDate = DateTime(str(currentDateTemp))
    except:
        currentDateTemp = DateTime()
        currentDate = DateTime(str(currentDateTemp))

"""
 IMPORTANT: add a section here for each view in your calendar 
"""
#MONTH view
if viewname == 'month':
    startDate = context.getStartOfMonth(currentDate)
    endDate = context.getEndOfMonth(currentDate)
    nextDate = (endDate + 1).Date()
    prevDate = (startDate - 1).Date()
    prevstring = 'previous month'
    nextstring = 'next month'
    currentstring = str(currentDate.Month())+' '+str(currentDate.year())
#WEEK BY DAY view
if viewname == 'weekbyday':
    startDate = context.getStartOfWeek(currentDate)
    endDate = context.getEndOfWeek(currentDate)
    nextDate = (currentDate + 7).Date()
    prevDate = (currentDate - 7).Date()
    prevstring = 'previous week'
    nextstring = 'next week'
    currentstring = str(startDate.Month())+' '+str(startDate.day())+', '+str(startDate.year())+' - '+str(endDate.Month())+' '+str(endDate.day())+', '+str(endDate.year())
#WEEK BY HOUR view
if viewname == 'weekbyhour':
    startDate = context.getStartOfWeek(currentDate,viewstarthour)
    endDate = context.getEndOfWeek(currentDate,viewendhour)
    nextDate = (currentDate + 7).Date()
    prevDate = (currentDate - 7).Date()
    prevstring = 'previous week'
    nextstring = 'next week'
    currentstring = str(startDate.Month())+' '+str(startDate.day())+', '+str(startDate.year())+' - '+str(endDate.Month())+' '+str(endDate.day())+', '+str(endDate.year())
#DAY view
if viewname == 'day':
    startDate = context.getStartOfDay(currentDate,viewstarthour)
    endDate = context.getEndOfDay(currentDate,viewendhour)
    nextDate = (currentDate + 1).Date()
    prevDate = (currentDate - 1).Date()
    prevstring = 'previous day'
    nextstring = 'next day'
    currentstring = str(currentDate.Month())+' '+str(currentDate.day())+', '+str(currentDate.year())+' ('+str(currentDate.Day())+')' 


#if a subCalendar, add this.
if context.getCXAttribute('isSubCalendar'):
    subcalname = context.absolute_url().split('/')[-1].upper()
#    subcalname = context.absolute_url().split('/')[-2]
#    scals = context.getCXAttribute('listOfSubCalendars')
#    scalnames = context.getCXAttribute('listOfSubjectTitles')
#    subcalname = context.matchinlists(scals,scalnames,subcalname)
else:
    subcalname = ''


#need these URLs for macros and querystrings
url =               context.absolute_url()
strDate =           currentDate.Date();
urlThis =           url+'/'+viewname+'?currentDate='+strDate+'&xmy='+xmy+'&xsub='+xsub
urlNext =           url+'/'+viewname+'?currentDate='+nextDate+'&xmy='+xmy+'&xsub='+xsub
urlPrev =           url+'/'+viewname+'?currentDate='+prevDate+'&xmy='+xmy+'&xsub='+xsub
urlWeek =           url+'/weekbyday?currentDate='+strDate+'&xmy='+xmy+'&xsub='+xsub
urlWeek2 =          url+'/weekbyhour?currentDate='+strDate+'&xmy='+xmy+'&xsub='+xsub
urlWeekend =        url+'/weekend?currentDate='+strDate+'&xmy='+xmy+'&xsub='+xsub
urlHelp =           url+'/helpcx?currentDate='+strDate+'&xmy='+xmy+'&xsub='+xsub
urlDay =            url+'/day?currentDate='+strDate+'&xmy='+xmy+'&xsub='+xsub
urlDaylist =        url+'/daylist?currentDate='+strDate+'&xmy='+xmy+'&xsub='+xsub
urlMonth =          url+'/month?currentDate='+strDate+'&xmy='+xmy+'&xsub='+xsub
urlMinusXsub =      url+'/'+viewname+'?currentDate='+strDate+'&xmy='+xmy
urlAllEventsChange =     test(xmy == '1', url + '/'+viewname+'?currentDate=' + strDate + '&xmy=0&xsub=' + xsub, url + '/'+viewname+'?currentDate=' + strDate + '&xmy=1&xsub=' + xsub)
allEventsChangeString =  test(xmy == '1', 'MINE: click for PUBLIC events','PUBLIC: click for MY events')





#marshall all these into a dictionary
cdict = {
         'ampm':ampm, 
         'viewstarthour':viewstarthour, 
         'viewendhour':viewendhour, 
         'xmy':xmy, 
         'xsub':xsub, 
         'xpub':xpub, 
         'xcrt':xcrt, 
         'currentDate':currentDate, 
         'startDate':startDate, 
         'endDate':endDate, 
         'nextDate':nextDate, 
         'prevDate':prevDate, 
         'prevstring':prevstring, 
         'nextstring':nextstring, 
         'currentstring':currentstring, 
         'subcalname':subcalname, 
         'urlThis':urlThis, 
         'urlNext':urlNext, 
         'urlPrev':urlPrev, 
         'urlWeek':urlWeek, 
         'urlWeek2':urlWeek2, 
         'urlWeekend':urlWeekend, 
         'urlHelp':urlHelp, 
         'urlDay':urlDay, 
         'urlDaylist':urlDaylist, 
         'urlMonth':urlMonth, 
         'urlMinusXsub':urlMinusXsub, 
         'urlAllEventsChange':urlAllEventsChange, 
         'allEventsChangeString':allEventsChangeString, 
        }

return cdict

